# -*- coding: utf-8 -*-

import googsystray
import gtk, gobject
import calendar
import threading
import copy
import time

from xml.etree import cElementTree as ET

import GIcon			
import GMain
import GConf

_g05 = "{http://schemas.google.com/gCal/2005}"


class GCal(GIcon.GIcon):
	def label_clicked(self, widget, event, data=None):
		label = widget.get_child()
		message = widget.get_data("thr_data")

		for i in GMain._accounts:
			if i["name"] == message["account"]:
				account = i
				break

		if data == "dismiss":
			message["marked"] = True
			gobject.idle_add(self.update_icon, None)


	def draw_message(self, message, show_all=True):
		mvbox = self.popup_window.vbox
		
		vbox = gtk.VBox()
		mvbox.pack_start(vbox, False, False, 0)
		vbox.set_data("msg_id", message["id"])
		self.popup_messages.append(vbox)
		
		event = message["data"]

		frame = gtk.Frame()
		vbox1 = gtk.VBox()
		frame.add(vbox1)
		vbox.pack_end(frame, False, False, 3)

		hbox = gtk.HBox()
		label = gtk.Label()
		label.set_markup("<b>" + event["title"] + "</b>")
		hbox.pack_start(label, False, False, 5)
		
		#fixme I really need a better way of doing this.
		
		if event["allday"]:
			label = gtk.Label(time.strftime("%x", time.localtime(event["start_time"])))
		else:			
			label = gtk.Label(time.strftime("%x %X", time.localtime(event["start_time"])))
		hbox.pack_end(label, False, False, 5)
		vbox1.pack_start(hbox, False, False, 5)


		hbox = gtk.HBox()
		label = gtk.Label()
		# The location of an event.
		label.set_markup("<b>" + _("Where:") + "</b>")
		hbox.pack_start(label, False, False, 5)
		if event["where"] is None or event["where"] == "":
			label = gtk.Label()
			label.set_markup("<i>" + _("No location provided") + "</i>")
		else:
			label = gtk.Label()
			label.set_markup(event["where"])
		hbox.pack_start(label, False, False, 5)
		vbox1.pack_start(hbox, False, False, 0)

		hbox = gtk.HBox()
		label = gtk.Label()
		# The description of an event
		label.set_markup("<b>" + _("Description:") + "</b>")
		hbox.pack_start(label, False, False, 5)
		if event["content"] is None:
			label = gtk.Label()
			label.set_markup("<i>" + _("No description provided") + "</i>")
		else:
			label = gtk.Label()
			label.set_markup(event["content"])
		hbox.pack_start(label, False, False, 5)
		vbox1.pack_start(hbox, False, False, 0)
		
		
		
		hbox = gtk.HBox()
		vbox1.pack_start(hbox, False, False, 2)

		button=GIcon.link_label()
		# This button dismisses a calendar alert.
		button.set_markup("<span color=\"#0000FF\" underline=\"single\">" + (_("Dismiss")) + "</span>")
		button.connect("button_press_event", self.label_clicked, "dismiss")
		button.set_data("thr_data", message)
		hbox.pack_end(button, False, False, 10)
		

	

	def check_events(self, account, cal, feedurl):
		sttime = time.gmtime()
		# We'll get a month worth of events.  
		endtime = time.gmtime(time.time() + (3600*24*30))
		
		req_times = time.strftime("&start-min=%Y-%m-%dT%H:%M:00-00:00", sttime)
		req_times += time.strftime("&start-max=%Y-%m-%dT%H:%M:00-00:00", endtime)
		req_times += time.strftime("&recurrence-expansion-start=%Y-%m-%dT%H:%M:00-00:00", sttime)
		req_times += time.strftime("&recurrence-expansion-end=%Y-%m-%dT%H:%M:00-00:00", endtime)
		#we're limiting by times here... so 1000 should be sufficiently large
		req_times += "&max-results=1000"
		
		headers = {"Authorization" : self.auth[account["name"]] }

		data = self.urlopen2(account, feedurl+"?ctz=UTC&singleevents=true" + req_times, headers=headers)
		if data == None:
			return True
			
		try:
			root = ET.XML(data)
		except:
			# This is typically a temporary condition.
			googsystray.error("XML Error")
			return True

#		title = root.find("{http://www.w3.org/2005/Atom}title").text

		for entry in root.findall("{http://www.w3.org/2005/Atom}entry"):
			entry_id = entry.find("{http://www.w3.org/2005/Atom}id").text

			upd = entry.find("{http://www.w3.org/2005/Atom}updated")
			tmpstr = upd.text[:-5] + " UTC"
			updtime = calendar.timegm(time.strptime(tmpstr, "%Y-%m-%dT%H:%M:%S %Z"))

			if cal["entries"].get(entry_id) != None:
				if cal["entries"][entry_id]["updated_time"] < updtime:
					del cal["entries"][entry_id]

			when = entry.find("{http://schemas.google.com/g/2005}when")

			# This happens, I think?  But not sure when.
			if when is None:
				continue
				
				
			# fixme also these :)
			#if when.find("{http://schemas.google.com/g/2005}reminder") is None:
			#	self.dumpit(entry)
				
			event_title = entry.find("{http://www.w3.org/2005/Atom}title").text
			event_content = entry.find("{http://www.w3.org/2005/Atom}content").text
			where = entry.find("{http://schemas.google.com/g/2005}where")
			# Where will always be here, even if blank.
			if where.get("valueString") != None:
				event_where = where.attrib["valueString"]
			else:
				event_where = None
				
			if event_title is None:
				event_title = _("Untitled Event")

			start_time = when.attrib["startTime"]
			if (len(start_time) == 10):
				start_time += "T00:00:00"
				st_time = time.mktime(time.strptime(start_time, "%Y-%m-%dT%H:%M:%S"))
				allday = True
			else:
				start_time = start_time[:-5] + " UTC"
				st_time = calendar.timegm(time.strptime(start_time, "%Y-%m-%dT%H:%M:%S %Z"))
				allday = False

			end_time = when.attrib["endTime"]
			if (len(end_time) == 10):
				end_time += "T00:00:00"
				en_time = time.mktime(time.strptime(end_time, "%Y-%m-%dT%H:%M:%S"))
			else:
				end_time = end_time[:-5] + " UTC"
				en_time = calendar.timegm(time.strptime(end_time, "%Y-%m-%dT%H:%M:%S %Z"))


			# No reason to worry about past events.
			#if (st_time < time.time()):
			#	continue

			cal["entries"][entry_id] = { "title" : event_title, 
							 "updated_time" : updtime,
							 "content" : event_content,
							 "where" : event_where,
							 "start_time" : st_time,
							 "end_time" : en_time,
							 "allday": allday,
							 "reminders": [] }
			
			for reminder in when.findall("{http://schemas.google.com/g/2005}reminder"):
				if (reminder.attrib["method"] == "alert"):
					cal["entries"][entry_id]["reminders"].append({"alertTime": st_time-int(reminder.attrib["minutes"])*60,
												  "hasReminded":False,"isActive":False})

	def make_new_calendar(self, account, webname, label, hidden):
		for i in self.get_config()["sub_notifications"]:
			if i["name"] == label and i["account"] == account["name"]:
				return
				
		new_not = copy.deepcopy(GConf.default_gcal_notification)
		new_not["account"] = account["name"]
		new_not["hidden"] = hidden
		new_not["webname"] = webname
		new_not["name"] = label
		self.get_config()["sub_notifications"].append(new_not)
			
		GMain._GConf.save_config()

	def make_tooltip(self):
		cnt = 0
		text = ""
		for i in self.messages_unread:
			if not i["marked"]:
				cnt += i["count"]
			text += _("Reminder: %(event_title)s") % {"event_title" :  i["data"]["title"]} + "\n"
		return text[:-1]

		
	 
	def icon_check_data(self, account):
		if account["name"] not in self.auth or self.auth[account["name"]] == None:
			self.get_auth(account, 'cl')

		if not "gcal_data" in account:
			account["gcal_data"] = {}
			

#		headers = {"Authorization" : self.auth[account["name"]] }
#		data = self.urlopen2(account, 'https://www.google.com/calendar/feeds/' + account["username"] + '/settings', headers=headers)
#		root = ET.XML(data)
#		self.dumpit(root)
		
		feed_url = 'https://www.google.com/calendar/feeds/default/allcalendars/full'
		try:
			if account["gcal_data"]["gsessionid"]:
				feed_url += "?gsessionid=" + account["gcal_data"]["gsessionid"]
		except:
			pass
			
		headers = {"Authorization" : self.auth[account["name"]] }
		(data, url) = self.urlopen2(account, feed_url, headers=headers, returl=True)
		
		c = url.find('gsessionid=')
		if c != -1:
			account["gcal_data"]["gsessionid"] = url[c+len('gsessionid='):]
		else:
			account["gcal_data"]["gsessionid"] = None
		
		if data == None:
			return True

		try:
			root = ET.XML(data)
		except:
			# This is typically a temporary condition.
			googsystray.error("XML Error")
			return True
		
		self.cal_lock.acquire()
		
		
		for entry in root.findall("{http://www.w3.org/2005/Atom}entry"):
			try:
				title = entry.find("{http://www.w3.org/2005/Atom}title").text
			except:
				googsystray.error("Calendar Entry has no title.")
				self.dumpit(entry)
				self.cal_lock.release()
				return
			
			try:
	                        color = entry.find(_g05 + "color").attrib["value"]
			except:
				color = "#000000"
				
			cal = None
			for i in self.calendars:
				if i["title"] == title and i["account"] == account["name"]:
					cal = i
					break
			if cal is None:
				cal = { "title": title, "account": account["name"], "last_checked" : 0, "last_updated" : 0, "entries" : {} }
				self.calendars.append(cal)

		
			upd = entry.find("{http://www.w3.org/2005/Atom}updated")
			tmpstr = upd.text[:-5] + " UTC"
			updtime = calendar.timegm(time.strptime(tmpstr, "%Y-%m-%dT%H:%M:%S %Z"))
			
			# Check once a day whether we need to or not -- this is important because
			# we only get a weeks worth of stuff.  I suppose we could do this less often
			
			if updtime > cal["last_updated"] or time.time() > (cal["last_checked"] + (3600*24)):
				cal["last_checked"] = time.time()
				cal["last_updated"] = updtime
				content = entry.find("{http://www.w3.org/2005/Atom}content")
				cal["url"] = content.attrib["src"]
			
				self.make_new_calendar(account, cal["url"], cal["title"], False)
				
				self.check_events(account, cal, content.attrib["src"])
				
		
		self.cal_lock.release()
		
		gobject.idle_add(self.check_calendar_once, None)
		return True
		
	def calendar_to_notification(self, cal):
		for i in self.get_config()["sub_notifications"]:
			if i["webname"] == cal["url"]:
				return i
		return None
		
	def check_calendar_once(self, data=None):
		self.check_calendar(data)

	def check_calendar(self, dummy=None):
		if not self.am_used():
			return False
			
		# Make sure we get the calendars list OK
		if not self.cal_lock.acquire(0):
			return True
			
		new_messages = {}
		for i in GMain._accounts:
			if i["services"][self.config]:
				new_messages[i["name"]] = []
		

		for cal in self.calendars:
			if cal["entries"] is None:
				continue
				
			notification = self.calendar_to_notification(cal)
			
			if notification is None:
				continue
			
			if notification["hidden"] == True:
				continue
				
			if notification["all_events"]:
				for entry in cal["entries"].items():
					if (entry[1]["start_time"] < time.time() and
					    entry[1]["end_time"] > time.time()):
						new_messages[cal["account"]].append(
							{ "id": entry[0],
							  "sub_id": "reminder",
							  "account": cal["account"],
							  "count": 1,
							  "title": _("Calendar Reminder"),
							  "summary": entry[1]["title"],
							  "icon": None,
							  "marked": False,
							  "data": copy.deepcopy(entry[1]),
							  "type": self.config, 
							  })
				continue
					    

			for entry in cal["entries"].items():
				for reminder in entry[1]["reminders"]:
					if reminder["alertTime"] < time.time() and entry[1]["end_time"] > time.time():
						new_messages[cal["account"]].append(
							{ "id": entry[0],
							  "sub_id": "reminder",
							  "account": cal["account"],
							  "count": 1,
							  "title": _("Calendar Reminder"),
							  "summary": entry[1]["title"],
							  "icon": None,
							  "marked": False,
							  "data": copy.deepcopy(entry[1]),
							  "type": self.config, 
							  })
						break

		self.cal_lock.release()	
		while not self.thread_lock.acquire(0):
			if not self.thread_run:
				return True
			time.sleep(0.1)
		for i in new_messages.items():
			self.merge_messages(i[0], i[1])
		self.thread_lock.release()

		
		return True
		
		

	def ical_read_time(self, tmstr):
		utc = False
		TZ = None
		
		tmstr = tmstr.strip(' \t\r\n')
		c = tmstr.find(":")
		time_str = tmstr[c+1:]
		if time_str[-1:] == "Z":
			time_str = tmstr[c+1:-1]
			utc = True
		
		c2 = tmstr.find("TZID=")
		if c2 != -1:
			if tmstr[c2+5:c] == "UTC":
				utc = True
			else:
				TZ=tmstr[c2+5:c]
				
		# TODO -- complain about non-UTC events first, then
		# actually handle them :)
		ptime = time.strptime(time_str, "%Y%m%dT%H%M%S")

		return ptime		
		
		
		

	def valarm_begin(self, data, l, event):
		while l < len(data):
			if data[l].startswith("END:VALARM"):
				l += 1
				break
			l += 1
	
		return (l, event)

        def vtext(self, data):
        	data = data.replace('<', '&lt;')
        	data = data.replace('>', '&gt;')
               	data = data.replace('&', '&amp;')
        	data = data.replace('\\n', '\n')
		data = data.replace('\\N', '\n')
		data = data.replace('\\,', ',')
		data = data.replace('\\;', ';')
		
		return data


	def vevent_begin(self, data, l, events):
		event = {}
		while l < len(data):
			if data[l].startswith("BEGIN:VALARM"):
				(l, event) = self.valarm_begin(data, l, event)
				continue
			elif data[l].startswith("DTSTART"):
				event["tstart"] = self.ical_read_time(data[l])
				l += 1
				continue
			elif data[l].startswith("DTEND"):
				event["tend"] = self.ical_read_time(data[l])
				l += 1
				continue
			elif data[l].startswith("DESCRIPTION"):
				c = data[l].find(":")
				event["description"] = self.vtext(data[l][c+1:])
				l += 1
				continue
			elif data[l].startswith("LOCATION"):
				c = data[l].find(":")
				event["location"] = self.vtext(data[l][c+1:])
				l += 1
				continue
			elif data[l].startswith("SUMMARY"):
				c = data[l].find(":")
				event["summary"] = self.vtext(data[l][c+1:])
				l += 1
				continue
			elif data[l].startswith("END:VEVENT"):
				l += 1
				break
			l += 1
	
		events.append(event)
		return (l, events)
		
	def vcalendar_begin(self, data, l, events):
		while l < len(data):
			if data[l].startswith("BEGIN:VEVENT"):
				(l, events) = self.vevent_begin(data, l, events)
				continue
			elif data[l].startswith("END:VCALENDAR"):
				l += 1
				break
			l += 1
	
		return (l, events)

	def read_ics_file(self, filename):
		try:
			f = open(filename, "r")
			data = f.readlines()
		except:
			# TODO report error
			return
		
		events = []
		l = 0
		
		while l < len(data):
			if data[l].startswith("BEGIN:VCALENDAR"):
				(l, events) = self.vcalendar_begin(data, l, events)
				continue
			l += 1
		
		f.close()
		
		event_strs = []
		
		for i in events:

			event_str = "<?xml version='1.0' encoding='UTF-8'?>\n"
			
			event_str +=("<entry xmlns='http://www.w3.org/2005/Atom'"+
				" xmlns:gd='http://schemas.google.com/g/2005'>"+
				"<category scheme='http://schemas.google.com/g/2005#kind'"+
				" term='http://schemas.google.com/g/2005#event'></category>")
			if "summary" in i:
				event_str +="<title type='text'>" + i["summary"] + "</title>"
			else:
				event_str +="<title type='text'>" + _("New Event") + "</title>"
			if "description" in i:
				event_str +="<content type='html'>" + i["description"] + "</content>"
			if "location" in i:
				event_str +="<gd:where valueString='" + i["location"] + "'></gd:where>"

			event_str +=("<gd:when startTime='" + time.strftime("%Y-%m-%dT%H:%M:%S.000Z", i["tstart"]) +
				"' endTime='" + time.strftime("%Y-%m-%dT%H:%M:%S.000Z", i["tend"]) +
				"'></gd:when>")
			event_str +="</entry>"
			
			event_strs.append(event_str)
			
		
		
	
		for acct in GMain._accounts:
			if not acct["services"][self.config]:
				continue
			base_url = "http://www.google.com/calendar/feeds/default/private/full"
			break

		if base_url is None:
			return


                if acct["gcal_data"]["gsessionid"]:
	                base_url += "?gsessionid=" + acct["gcal_data"]["gsessionid"]
		
		headers = {"Authorization" : self.auth[acct["name"]],
			   "Content-Length": len(event_str),
			   "Content-Type"  : "application/atom+xml" }
		data = self.urlopen2(acct, base_url, headers=headers, post_data=event_str);
		
		
	def icon_stop(self):
		if self.cal_check_timer != -1:
			gobject.source_remove(self.cal_check_timer)
		return
		
	def icon_start (self):
		if not self.am_used():
			return
		self.cal_check_timer = gobject.timeout_add_seconds(60, self.check_calendar, None)
		return


				
	def __init__(self):
		self.config = "gcal"
		self.auth = {}
		
		self.cal_lock = threading.Lock()
	
		self.cal_check_timer = -1
		self.calendars = []
		
		GIcon.GIcon.__init__(self)
